--[[		ChatHide
]]--		by Scale
local ChatHide = CreateFrame("Frame", "ChatHideFrame", nil)
local toggle = true
local CombatOnly = true

SLASH_CEB1, SLASH_CEB2 = '/ceb', '/chathide';
local function slashhandler(msg, editbox)
 if (msg == 'combat') then
	  CombatOnly = not CombatOnly
	  if CombatOnly then
	  		_G['GeneralDockManager']:SetAlpha(1)
	  		for i = 1, NUM_CHAT_WINDOWS do
				local chatframe = _G["ChatFrame"..i]
				if chatframe then
					chatframe:SetAlpha(1)
				end
			end
	  end
	  print('Combat only is ' .. tostring(CombatOnly))
	  return
 end
 
 if (msg == 'toggle') then
	  toggle = not toggle
	  if not toggle then
	  		_G['GeneralDockManager']:SetAlpha(1)
	  		for i = 1, NUM_CHAT_WINDOWS do
				local chatframe = _G["ChatFrame"..i]
				if chatframe then
					chatframe:SetAlpha(1)
				end
			end
	  end
	  print('ChatHide enabled is ' .. tostring(toggle))
	  return
 end
 
 print('chathide: valid commands:')
 print('chathide: /ceb combat ')
 print('chathide: /ceb toggle')
end
SlashCmdList["CEB"] = slashhandler;

local function onEvent(self, event, ...)
	--print(event)
	if (event == "ADDON_LOADED") then
		if _combatOnly == nil then
			_combatOnly = true
		else
			CombatOnly = _combatOnly
		end
		
		if _enabled == nil then
			_enabled = true
		else
			toggle = _enabled
		end
	end
	
	if (event == "PLAYER_LOGOUT") then
		_combatOnly = CombatOnly
		_enabled = toggle	
	end
	
	if not toggle then
		return
	end
	
	if(event == "CHAT_MSG_CHANNEL" and channelNumbers and not channelNumbers[arg8]) then return end
	
	if (event == "PLAYER_REGEN_DISABLED") then
		_G['GeneralDockManager']:SetAlpha(0)
		for i = 1, NUM_CHAT_WINDOWS do
			local chatframe = _G["ChatFrame"..i]
			if chatframe then
				chatframe:SetAlpha(0)
			end
		end
	end
	
	if (event == "PLAYER_REGEN_ENABLED") then
		_G['GeneralDockManager']:SetAlpha(1)
		for i = 1, NUM_CHAT_WINDOWS do
			local chatframe = _G["ChatFrame"..i]
			if chatframe then
				chatframe:SetAlpha(1)
			end
		end
	end
	
	--Show Events
end

ChatHide:SetScript("OnEvent", onEvent)
ChatHide:RegisterEvent("PLAYER_REGEN_ENABLED")
ChatHide:RegisterEvent("PLAYER_REGEN_DISABLED")
ChatHide:RegisterEvent("ADDON_LOADED")
ChatHide:RegisterEvent("PLAYER_LOGOUT")

for i = 1, NUM_CHAT_WINDOWS do
	local chatframe = _G["ChatFrame"..i]
	
	if chatframe then
		local updater = CreateFrame("Frame", nil, chatframe)
		
		updater:SetScript("OnUpdate", function(self)
		if toggle then
			for i = 1, NUM_CHAT_WINDOWS do
				local ceb = _G["ChatFrame" .. i .. "EditBox"]
				if ceb then
					if (ceb:GetAlpha() == 1) then
						_G['GeneralDockManager']:SetAlpha(1)
						self.Frame:SetAlpha(1)
						return
					elseif (not MouseIsOver(self.Frame)) then
						if(UnitAffectingCombat("player")) then
							_G['GeneralDockManager']:SetAlpha(0)
							self.Frame:SetAlpha(0)
						elseif (not combatonly) then
							_G['GeneralDockManager']:SetAlpha(1)
							self.Frame:SetAlpha(1)
						end
					end
				end
			end
				if(MouseIsOver(self.Frame) and not self.wasOver) then
					self.wasOver = true
					_G['GeneralDockManager']:SetAlpha(1)
					self.Frame:SetAlpha(1)
				elseif(self.wasOver and not MouseIsOver(self.Frame)) then
					self.wasOver = nil
					if CombatOnly then
						if(UnitAffectingCombat("player")) then
							_G['GeneralDockManager']:SetAlpha(0)
							self.Frame:SetAlpha(0)
						end
					else
					self.Frame:SetAlpha(0)
					_G['GeneralDockManager']:SetAlpha(0)
					end
				end
			end
		end)
		
		updater.Frame = chatframe
	end
end